(function (_, kotlin_clikt_clikt, kotlin_kotlin, kotlin_mordant_mordant) {
  'use strict';
  //region block: imports
  var CoreCliktCommand = kotlin_clikt_clikt.$_$.b;
  var VOID = kotlin_kotlin.$_$.f;
  var Unit_instance = kotlin_kotlin.$_$.d4;
  var protoOf = kotlin_kotlin.$_$.z9;
  var initMetadataForClass = kotlin_kotlin.$_$.z8;
  var selfAndAncestors = kotlin_clikt_clikt.$_$.g;
  var mapNotNull = kotlin_kotlin.$_$.eb;
  var firstOrNull = kotlin_kotlin.$_$.za;
  var Terminal_init_$Create$ = kotlin_mordant_mordant.$_$.g;
  var last = kotlin_kotlin.$_$.db;
  var MultiplatformSystem_instance = kotlin_mordant_mordant.$_$.i;
  var FileNotFound = kotlin_clikt_clikt.$_$.c;
  var Terminal = kotlin_mordant_mordant.$_$.b;
  var Whitespace_NORMAL_getInstance = kotlin_mordant_mordant.$_$.e;
  var Text_init_$Create$ = kotlin_mordant_mordant.$_$.h;
  var AbstractHelpFormatter = kotlin_clikt_clikt.$_$.i;
  var verticalLayout = kotlin_mordant_mordant.$_$.a;
  var charSequenceLength = kotlin_kotlin.$_$.p8;
  var definitionList = kotlin_mordant_mordant.$_$.c;
  var withPadding = kotlin_mordant_mordant.$_$.d;
  var collectionSizeOrDefault = kotlin_kotlin.$_$.b5;
  var ArrayList_init_$Create$ = kotlin_kotlin.$_$.i;
  var ensureNotNull = kotlin_kotlin.$_$.qe;
  var drop = kotlin_kotlin.$_$.ob;
  var plus = kotlin_kotlin.$_$.xe;
  var Whitespace_PRE_WRAP_getInstance = kotlin_mordant_mordant.$_$.f;
  var isBlank = kotlin_kotlin.$_$.vb;
  var replace = kotlin_kotlin.$_$.hc;
  //endregion
  //region block: pre-declaration
  initMetadataForClass(CliktCommand, 'CliktCommand', VOID, CoreCliktCommand);
  initMetadataForClass(MordantHelpFormatter, 'MordantHelpFormatter', VOID, AbstractHelpFormatter);
  //endregion
  function CliktCommand(name) {
    name = name === VOID ? null : name;
    CoreCliktCommand.call(this, name);
    installMordant(this);
  }
  function installMordant(_this__u8e3s4, force) {
    force = force === VOID ? false : force;
    _this__u8e3s4.y1p(installMordant$lambda(force));
  }
  function get_terminal(_this__u8e3s4) {
    // Inline function 'com.github.ajalt.clikt.core.Context.findObject' call
    var key = 'mordant_terminal';
    var tmp = selfAndAncestors(_this__u8e3s4);
    var tmp0_elvis_lhs = firstOrNull(mapNotNull(tmp, _get_terminal_$lambda_5keric(key)));
    var tmp_0;
    if (tmp0_elvis_lhs == null) {
      // Inline function 'kotlin.also' call
      var this_0 = Terminal_init_$Create$();
      // Inline function 'kotlin.contracts.contract' call
      // Inline function 'com.github.ajalt.clikt.core.<get-terminal>.<anonymous>' call
      // Inline function 'kotlin.collections.set' call
      var this_1 = last(selfAndAncestors(_this__u8e3s4)).w1n_1;
      var key_0 = 'mordant_terminal';
      this_1.m2(key_0, this_0);
      tmp_0 = this_0;
    } else {
      tmp_0 = tmp0_elvis_lhs;
    }
    return tmp_0;
  }
  function installMordant$lambda$lambda(it) {
    return new MordantHelpFormatter(it);
  }
  function installMordant$lambda$lambda_0(it) {
    return MultiplatformSystem_instance.f2c(it);
  }
  function installMordant$lambda$lambda_1(it) {
    var tmp0_elvis_lhs = MultiplatformSystem_instance.h2c(it);
    var tmp;
    if (tmp0_elvis_lhs == null) {
      throw new FileNotFound(it);
    } else {
      tmp = tmp0_elvis_lhs;
    }
    return tmp;
  }
  function installMordant$lambda$lambda_2(it) {
    MultiplatformSystem_instance.g2c(it);
    return Unit_instance;
  }
  function installMordant$lambda$lambda_3(context, message, trailingNewline, err) {
    if (trailingNewline) {
      get_terminal(context).g2m(message, VOID, VOID, VOID, VOID, err);
    } else {
      get_terminal(context).e2m(message, VOID, VOID, VOID, VOID, err);
    }
    return Unit_instance;
  }
  function installMordant$lambda($force) {
    return function ($this$configureContext) {
      var tmp;
      if (!$force && !($this$configureContext.z1p_1 == null)) {
        return Unit_instance;
      }
      var tmp_0 = $this$configureContext;
      tmp_0.e1q_1 = installMordant$lambda$lambda;
      var tmp_1 = $this$configureContext;
      tmp_1.m1q_1 = installMordant$lambda$lambda_0;
      var tmp_2 = $this$configureContext;
      tmp_2.h1q_1 = installMordant$lambda$lambda_1;
      var tmp_3 = $this$configureContext;
      tmp_3.p1q_1 = installMordant$lambda$lambda_2;
      var tmp_4 = $this$configureContext;
      tmp_4.o1q_1 = installMordant$lambda$lambda_3;
      return Unit_instance;
    };
  }
  function _get_terminal_$lambda_5keric($key) {
    return function (it) {
      var tmp = it.w1n_1.e2($key);
      return tmp instanceof Terminal ? tmp : null;
    };
  }
  function MordantHelpFormatter$formatHelp$lambda(this$0, $error, $prolog, $epilog, $parameters, $programName) {
    return function ($this$verticalLayout) {
      $this$verticalLayout.w2i(1);
      $this$verticalLayout.t2i(this$0.n1w($error, $prolog, $epilog, $parameters, $programName));
      return Unit_instance;
    };
  }
  function MordantHelpFormatter$renderUsage$lambda($prog, $usageParts) {
    return function ($this$definitionList) {
      $this$definitionList.q2m($prog, Text_init_$Create$($usageParts, Whitespace_NORMAL_getInstance()));
      $this$definitionList.k2m_1 = true;
      $this$definitionList.n2m(1);
      return Unit_instance;
    };
  }
  function MordantHelpFormatter$renderProlog$lambda($this$withPadding) {
    $this$withPadding.t2k_1 = 2;
    return Unit_instance;
  }
  function MordantHelpFormatter$renderParameters$lambda(this$0, $parameters) {
    return function ($this$definitionList) {
      var _iterator__ex2g4s = this$0.a1y($parameters).m();
      while (_iterator__ex2g4s.n()) {
        var section = _iterator__ex2g4s.o();
        $this$definitionList.q2m(section.u1v_1, section.v1v_1);
      }
      return Unit_instance;
    };
  }
  function MordantHelpFormatter$renderOptionGroup$lambda($this$withPadding) {
    $this$withPadding.q2k_1 = 1;
    $this$withPadding.t2k_1 = 2;
    $this$withPadding.s2k_1 = 1;
    return Unit_instance;
  }
  function MordantHelpFormatter$renderOptionGroup$lambda_0($markdown, this$0, $options) {
    return function ($this$verticalLayout) {
      $this$verticalLayout.v2i($markdown);
      $this$verticalLayout.v2i(this$0.k1y($options));
      return Unit_instance;
    };
  }
  function MordantHelpFormatter$buildParameterList$lambda($rows, this$0) {
    return function ($this$definitionList) {
      $this$definitionList.k2m_1 = true;
      var _iterator__ex2g4s = $rows.m();
      while (_iterator__ex2g4s.n()) {
        var row = _iterator__ex2g4s.o();
        $this$definitionList.r2m(this$0.f1z(row), this$0.g1z(row));
      }
      return Unit_instance;
    };
  }
  function MordantHelpFormatter(context, requiredOptionMarker, showDefaultValues, showRequiredTag) {
    requiredOptionMarker = requiredOptionMarker === VOID ? null : requiredOptionMarker;
    showDefaultValues = showDefaultValues === VOID ? false : showDefaultValues;
    showRequiredTag = showRequiredTag === VOID ? false : showRequiredTag;
    AbstractHelpFormatter.call(this, context, requiredOptionMarker, showDefaultValues, showRequiredTag);
  }
  protoOf(MordantHelpFormatter).v2n = function () {
    return get_terminal(this.b1w_1).q2f_1;
  };
  protoOf(MordantHelpFormatter).s1p = function (error, prolog, epilog, parameters, programName) {
    var widget = verticalLayout(MordantHelpFormatter$formatHelp$lambda(this, error, prolog, epilog, parameters, programName));
    return get_terminal(this.b1w_1).h2m(widget);
  };
  protoOf(MordantHelpFormatter).p1w = function (parameters, error) {
    return Text_init_$Create$(this.t1w(parameters, error));
  };
  protoOf(MordantHelpFormatter).o1w = function (parameters, programName) {
    var title = this.w2n(this.m1w().a1z());
    var prog = title + ' ' + programName;
    var usageParts = this.x1w(parameters);
    var tmp;
    // Inline function 'kotlin.text.isEmpty' call
    if (charSequenceLength(usageParts) === 0) {
      tmp = Text_init_$Create$(prog, Whitespace_NORMAL_getInstance());
    } else {
      tmp = definitionList(MordantHelpFormatter$renderUsage$lambda(prog, usageParts));
    }
    return tmp;
  };
  protoOf(MordantHelpFormatter).q1w = function (prolog) {
    var tmp = this.x2n(prolog);
    return withPadding(tmp, false, MordantHelpFormatter$renderProlog$lambda);
  };
  protoOf(MordantHelpFormatter).s1w = function (epilog) {
    return this.x2n(epilog);
  };
  protoOf(MordantHelpFormatter).r1w = function (parameters) {
    return definitionList(MordantHelpFormatter$renderParameters$lambda(this, parameters));
  };
  protoOf(MordantHelpFormatter).y1x = function (help, parameters) {
    // Inline function 'kotlin.collections.map' call
    // Inline function 'kotlin.collections.mapTo' call
    var destination = ArrayList_init_$Create$(collectionSizeOrDefault(parameters, 10));
    var tmp0_iterator = parameters.m();
    while (tmp0_iterator.n()) {
      var item = tmp0_iterator.o();
      var tmp$ret$0 = this.d1y(item);
      destination.e(tmp$ret$0);
    }
    var options = destination;
    if (help == null)
      return this.k1y(options);
    var tmp = this.x2n(help);
    var markdown = withPadding(tmp, false, MordantHelpFormatter$renderOptionGroup$lambda);
    return verticalLayout(MordantHelpFormatter$renderOptionGroup$lambda_0(markdown, this, options));
  };
  protoOf(MordantHelpFormatter).j1w = function (name) {
    // Inline function 'kotlin.text.lowercase' call
    // Inline function 'kotlin.js.asDynamic' call
    return '<' + name.toLowerCase() + '>';
  };
  protoOf(MordantHelpFormatter).i1y = function (name) {
    return this.v2n().f2f('danger').d28(name);
  };
  protoOf(MordantHelpFormatter).r1y = function (name) {
    return this.v2n().f2f('muted').d28(name);
  };
  protoOf(MordantHelpFormatter).h1w = function (name) {
    return this.v2n().f2f('info').d28(name);
  };
  protoOf(MordantHelpFormatter).k1w = function (name) {
    return this.v2n().f2f('info').d28(name);
  };
  protoOf(MordantHelpFormatter).l1w = function (name) {
    return this.v2n().f2f('info').d28(name);
  };
  protoOf(MordantHelpFormatter).z1x = function (title) {
    return this.v2n().f2f('warning').d28(title);
  };
  protoOf(MordantHelpFormatter).w2n = function (title) {
    return this.v2n().f2f('warning').d28(title);
  };
  protoOf(MordantHelpFormatter).v1w = function (title) {
    return this.v2n().f2f('danger').d28(title);
  };
  protoOf(MordantHelpFormatter).a1x = function (parameter) {
    return this.v2n().f2f('muted').d28(parameter);
  };
  protoOf(MordantHelpFormatter).t1y = function (metavar) {
    return this.v2n().f2f('warning').s2b(this.v2n().f2f('muted')).d28(metavar);
  };
  protoOf(MordantHelpFormatter).f1z = function (row) {
    var tmp;
    // Inline function 'kotlin.text.isNullOrEmpty' call
    var this_0 = row.y1v_1;
    // Inline function 'kotlin.contracts.contract' call
    if (this_0 == null || charSequenceLength(this_0) === 0) {
      tmp = '  ';
    } else {
      // Inline function 'kotlin.text.ifEmpty' call
      var this_1 = drop('  ', ensureNotNull(row.y1v_1).length);
      // Inline function 'kotlin.contracts.contract' call
      var tmp_0;
      // Inline function 'kotlin.text.isEmpty' call
      if (charSequenceLength(this_1) === 0) {
        // Inline function 'com.github.ajalt.clikt.output.MordantHelpFormatter.renderDefinitionTerm.<anonymous>' call
        tmp_0 = ' ';
      } else {
        tmp_0 = this_1;
      }
      var tmp$ret$3 = tmp_0;
      tmp = plus(row.y1v_1, tmp$ret$3);
    }
    var termPrefix = tmp;
    return Text_init_$Create$(termPrefix + row.w1v_1, Whitespace_PRE_WRAP_getInstance());
  };
  protoOf(MordantHelpFormatter).g1z = function (row) {
    return isBlank(row.x1v_1) ? Text_init_$Create$('') : this.x2n(row.x1v_1);
  };
  protoOf(MordantHelpFormatter).k1y = function (rows) {
    return definitionList(MordantHelpFormatter$buildParameterList$lambda(rows, this));
  };
  protoOf(MordantHelpFormatter).x2n = function (text) {
    return Text_init_$Create$(replace(text, '\n\n', '\x85\x85'), Whitespace_NORMAL_getInstance());
  };
  //region block: exports
  _.$_$ = _.$_$ || {};
  _.$_$.a = CliktCommand;
  //endregion
  return _;
}(module.exports, require('./clikt-clikt.js'), require('./kotlin-kotlin-stdlib.js'), require('./mordant-mordant.js')));

//# sourceMappingURL=clikt-clikt-mordant.js.map
