(function (_, kotlin_kotlin) {
  'use strict';
  //region block: imports
  var imul = Math.imul;
  var log2 = Math.log2;
  var protoOf = kotlin_kotlin.$_$.z9;
  var initMetadataForInterface = kotlin_kotlin.$_$.c9;
  var toString = kotlin_kotlin.$_$.da;
  var IllegalArgumentException_init_$Create$ = kotlin_kotlin.$_$.h1;
  var initMetadataForClass = kotlin_kotlin.$_$.z8;
  var getStringHashCode = kotlin_kotlin.$_$.x8;
  var THROW_CCE = kotlin_kotlin.$_$.ae;
  var initMetadataForObject = kotlin_kotlin.$_$.e9;
  var ArrayList_init_$Create$ = kotlin_kotlin.$_$.j;
  var charSequenceLength = kotlin_kotlin.$_$.p8;
  var charSequenceGet = kotlin_kotlin.$_$.o8;
  var toString_0 = kotlin_kotlin.$_$.w1;
  var Unit_instance = kotlin_kotlin.$_$.d4;
  var _Char___init__impl__6a9atx = kotlin_kotlin.$_$.t1;
  var arrayConcat = kotlin_kotlin.$_$.a;
  var listOf = kotlin_kotlin.$_$.p6;
  var withSign = kotlin_kotlin.$_$.fa;
  var trimMargin = kotlin_kotlin.$_$.gd;
  var hashCode = kotlin_kotlin.$_$.y8;
  var equals = kotlin_kotlin.$_$.s8;
  var VOID = kotlin_kotlin.$_$.f;
  var initMetadataForCompanion = kotlin_kotlin.$_$.a9;
  var coerceAtLeast = kotlin_kotlin.$_$.ha;
  var getNumberHashCode = kotlin_kotlin.$_$.v8;
  var numberToDouble = kotlin_kotlin.$_$.v9;
  var roundToInt = kotlin_kotlin.$_$.ea;
  var coerceIn = kotlin_kotlin.$_$.la;
  var Char = kotlin_kotlin.$_$.md;
  var toInt = kotlin_kotlin.$_$.yc;
  var numberRangeToNumber = kotlin_kotlin.$_$.t9;
  var slice = kotlin_kotlin.$_$.kc;
  var startsWith = kotlin_kotlin.$_$.mc;
  var isInterface = kotlin_kotlin.$_$.n9;
  var contentEquals = kotlin_kotlin.$_$.e5;
  var coerceAtLeast_0 = kotlin_kotlin.$_$.ja;
  var objectCreate = kotlin_kotlin.$_$.y9;
  //endregion
  //region block: pre-declaration
  function toXYZ() {
    return this.l25().m25();
  }
  initMetadataForInterface(Color, 'Color');
  initMetadataForClass(ColorComponentInfo, 'ColorComponentInfo');
  initMetadataForClass(WhitePoint, 'WhitePoint');
  initMetadataForObject(Illuminant, 'Illuminant');
  initMetadataForClass(Matrix, 'Matrix');
  initMetadataForCompanion(Companion);
  initMetadataForClass(Ansi16, 'Ansi16', VOID, VOID, [Color]);
  initMetadataForCompanion(Companion_0);
  initMetadataForClass(Ansi256, 'Ansi256', VOID, VOID, [Color]);
  initMetadataForCompanion(Companion_1);
  initMetadataForClass(HSV, 'HSV', VOID, VOID, [Color]);
  initMetadataForClass(ICtCp, 'ICtCp', VOID, VOID, [Color]);
  initMetadataForObject(PqNonlinearity, 'PqNonlinearity');
  initMetadataForClass(GammaTransferFunctions, 'GammaTransferFunctions');
  initMetadataForObject(LinearTransferFunctions, 'LinearTransferFunctions');
  function invoke$default(r, g, b, alpha, $super) {
    alpha = alpha === VOID ? 1.0 : alpha;
    return $super === VOID ? this.w26(r, g, b, alpha) : $super.w26.call(this, r, g, b, alpha);
  }
  function invoke(r, g, b, alpha) {
    return this.w26(numberToDouble(r), numberToDouble(g), numberToDouble(b), numberToDouble(alpha));
  }
  function invoke$default_0(r, g, b, alpha, $super) {
    alpha = alpha === VOID ? 1.0 : alpha;
    return $super === VOID ? this.b28(r, g, b, alpha) : invoke(r, g, b, alpha);
  }
  function from255(r, g, b, alpha) {
    return this.w26(r / 255.0, g / 255.0, b / 255.0, alpha / 255.0);
  }
  function from255$default(r, g, b, alpha, $super) {
    alpha = alpha === VOID ? 255 : alpha;
    return $super === VOID ? this.c28(r, g, b, alpha) : from255(r, g, b, alpha);
  }
  function invoke_0(hex) {
    var tmp = parseHex(validateHex(hex), 0);
    var tmp_0 = parseHex(hex, 1);
    var tmp_1 = parseHex(hex, 2);
    var tmp_2;
    // Inline function 'kotlin.let' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.github.ajalt.colormath.model.RGBColorSpace.invoke.<anonymous>' call
    var it = get_hexLength(hex);
    if (it === 4 || it === 8) {
      tmp_2 = parseHex(hex, 3);
    } else {
      tmp_2 = 255;
    }
    return this.c28(tmp, tmp_0, tmp_1, tmp_2);
  }
  initMetadataForInterface(RGBColorSpace, 'RGBColorSpace');
  initMetadataForCompanion(Companion_2, VOID, [RGBColorSpace]);
  initMetadataForClass(RGB, 'RGB', VOID, VOID, [Color]);
  initMetadataForObject(RGBColorSpaces, 'RGBColorSpaces');
  initMetadataForObject(SRGB, 'SRGB', VOID, VOID, [RGBColorSpace]);
  initMetadataForClass(RGBColorSpaceImpl, 'RGBColorSpaceImpl', VOID, VOID, [RGBColorSpace]);
  initMetadataForObject(SRGBTransferFunctions, 'SRGBTransferFunctions');
  initMetadataForObject(ACESccTransferFunctions, 'ACESccTransferFunctions');
  initMetadataForObject(ACEScctTransferFunctions, 'ACEScctTransferFunctions');
  initMetadataForObject(BT2020TransferFunctions, 'BT2020TransferFunctions');
  initMetadataForObject(BT709TransferFunctions, 'BT709TransferFunctions');
  initMetadataForObject(ROMMTransferFunctions, 'ROMMTransferFunctions');
  initMetadataForInterface(XYZColorSpace, 'XYZColorSpace');
  initMetadataForCompanion(Companion_3, VOID, [XYZColorSpace]);
  initMetadataForClass(XYZ, 'XYZ', VOID, VOID, [Color]);
  initMetadataForObject(XYZColorSpaces, 'XYZColorSpaces');
  initMetadataForClass(XYZColorSpaceImpl, 'XYZColorSpaceImpl', VOID, VOID, [XYZColorSpace]);
  initMetadataForClass(xyY, 'xyY');
  //endregion
  function Color() {
  }
  function ColorComponentInfo(name, isPolar, min, max) {
    this.s25_1 = name;
    this.t25_1 = isPolar;
    this.u25_1 = min;
    this.v25_1 = max;
    // Inline function 'kotlin.require' call
    // Inline function 'kotlin.contracts.contract' call
    if (!(this.u25_1 <= this.v25_1)) {
      // Inline function 'com.github.ajalt.colormath.ColorComponentInfo.<anonymous>' call
      var message = 'min must be less than or equal to max';
      throw IllegalArgumentException_init_$Create$(toString(message));
    }
  }
  function WhitePoint(name, chromaticity) {
    this.w25_1 = name;
    this.x25_1 = chromaticity;
  }
  protoOf(WhitePoint).toString = function () {
    return this.w25_1;
  };
  protoOf(WhitePoint).hashCode = function () {
    var result = getStringHashCode(this.w25_1);
    result = imul(result, 31) + this.x25_1.hashCode() | 0;
    return result;
  };
  protoOf(WhitePoint).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof WhitePoint))
      return false;
    var tmp0_other_with_cast = other instanceof WhitePoint ? other : THROW_CCE();
    if (!(this.w25_1 === tmp0_other_with_cast.w25_1))
      return false;
    if (!this.x25_1.equals(tmp0_other_with_cast.x25_1))
      return false;
    return true;
  };
  function Illuminant() {
    Illuminant_instance = this;
    this.y25_1 = new WhitePoint('A', xyY_init_$Create$(0.44758, 0.40745));
    this.z25_1 = new WhitePoint('B', xyY_init_$Create$(0.34842, 0.35161));
    this.a26_1 = new WhitePoint('C', xyY_init_$Create$(0.31006, 0.31616));
    this.b26_1 = new WhitePoint('D50', xyY_init_$Create$(0.3457, 0.3585));
    this.c26_1 = new WhitePoint('D55', xyY_init_$Create$(0.33243, 0.34744));
    this.d26_1 = new WhitePoint('D65', xyY_init_$Create$(0.3127, 0.329));
    this.e26_1 = new WhitePoint('D75', xyY_init_$Create$(0.29903, 0.31488));
    this.f26_1 = new WhitePoint('E', xyY_init_$Create$(1.0 / 3.0, 1.0 / 3.0));
  }
  var Illuminant_instance;
  function Illuminant_getInstance() {
    if (Illuminant_instance == null)
      new Illuminant();
    return Illuminant_instance;
  }
  function get_alphaInfo() {
    _init_properties_ColorSpaceUtils_kt__cnwylg();
    return alphaInfo;
  }
  var alphaInfo;
  function zeroOneComponentInfo(name) {
    _init_properties_ColorSpaceUtils_kt__cnwylg();
    // Inline function 'kotlin.collections.buildList' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'kotlin.collections.buildListInternal' call
    // Inline function 'kotlin.apply' call
    var this_0 = ArrayList_init_$Create$();
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.github.ajalt.colormath.internal.zeroOneComponentInfo.<anonymous>' call
    // Inline function 'kotlin.text.mapTo' call
    var inductionVariable = 0;
    while (inductionVariable < charSequenceLength(name)) {
      var item = charSequenceGet(name, inductionVariable);
      inductionVariable = inductionVariable + 1 | 0;
      // Inline function 'com.github.ajalt.colormath.internal.zeroOneComponentInfo.<anonymous>.<anonymous>' call
      var tmp$ret$0 = new ColorComponentInfo(toString_0(item), false, 0.0, 1.0);
      this_0.e(tmp$ret$0);
    }
    this_0.e(get_alphaInfo());
    return this_0.m5();
  }
  function polarComponentInfo(name, l, r) {
    _init_properties_ColorSpaceUtils_kt__cnwylg();
    // Inline function 'kotlin.collections.buildList' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'kotlin.collections.buildListInternal' call
    // Inline function 'kotlin.apply' call
    var this_0 = ArrayList_init_$Create$();
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.github.ajalt.colormath.internal.polarComponentInfo.<anonymous>' call
    // Inline function 'kotlin.text.mapTo' call
    var inductionVariable = 0;
    while (inductionVariable < charSequenceLength(name)) {
      var item = charSequenceGet(name, inductionVariable);
      inductionVariable = inductionVariable + 1 | 0;
      // Inline function 'com.github.ajalt.colormath.internal.polarComponentInfo.<anonymous>.<anonymous>' call
      var tmp$ret$0 = new ColorComponentInfo(toString_0(item), item === _Char___init__impl__6a9atx(72), item === _Char___init__impl__6a9atx(72) ? 0.0 : l, item === _Char___init__impl__6a9atx(72) ? 360.0 : r);
      this_0.e(tmp$ret$0);
    }
    this_0.e(get_alphaInfo());
    return this_0.m5();
  }
  function componentInfoList(c) {
    _init_properties_ColorSpaceUtils_kt__cnwylg();
    return listOf(arrayConcat([c, [get_alphaInfo()]]));
  }
  var properties_initialized_ColorSpaceUtils_kt_kskdoe;
  function _init_properties_ColorSpaceUtils_kt__cnwylg() {
    if (!properties_initialized_ColorSpaceUtils_kt_kskdoe) {
      properties_initialized_ColorSpaceUtils_kt_kskdoe = true;
      alphaInfo = new ColorComponentInfo('alpha', false, 0.0, 1.0);
    }
  }
  function get_CAT02_XYZ_TO_LMS() {
    _init_properties_Constants_kt__atb1ur();
    return CAT02_XYZ_TO_LMS;
  }
  var CAT02_XYZ_TO_LMS;
  function get_CAT02_LMS_TO_XYZ() {
    _init_properties_Constants_kt__atb1ur();
    return CAT02_LMS_TO_XYZ;
  }
  var CAT02_LMS_TO_XYZ;
  var properties_initialized_Constants_kt_w4w61t;
  function _init_properties_Constants_kt__atb1ur() {
    if (!properties_initialized_Constants_kt_w4w61t) {
      properties_initialized_Constants_kt_w4w61t = true;
      CAT02_XYZ_TO_LMS = _Matrix___init__impl__q3kp4w_0(+0.7328, +0.4296, -0.1624, -0.7036, +1.6975, +0.0061, +0.003, +0.0136, +0.9834);
      CAT02_LMS_TO_XYZ = inverse(get_CAT02_XYZ_TO_LMS());
    }
  }
  function spow(_this__u8e3s4, p) {
    return spow_0(_this__u8e3s4, p);
  }
  function normalizeDeg(_this__u8e3s4) {
    return (_this__u8e3s4 % 360.0 + 360.0) % 360.0;
  }
  function spow_0(_this__u8e3s4, p) {
    // Inline function 'kotlin.math.pow' call
    // Inline function 'kotlin.math.absoluteValue' call
    var this_0 = Math.abs(_this__u8e3s4);
    var tmp$ret$1 = Math.pow(this_0, p);
    return withSign(tmp$ret$1, _this__u8e3s4);
  }
  function normalizeDeg_0(_this__u8e3s4) {
    return (_this__u8e3s4 % 360.0 + 360.0) % 360.0;
  }
  function _Matrix___init__impl__q3kp4w(rowMajor) {
    return rowMajor;
  }
  function _Matrix___get_rowMajor__impl__vmgxkq($this) {
    return $this;
  }
  function _Matrix___init__impl__q3kp4w_0(v00, v10, v20, v01, v11, v21, v02, v12, v22) {
    // Inline function 'kotlin.floatArrayOf' call
    var tmp$ret$0 = new Float32Array([v00, v10, v20, v01, v11, v21, v02, v12, v22]);
    return _Matrix___init__impl__q3kp4w(tmp$ret$0);
  }
  function Matrix__copy_impl_kmkvzd($this) {
    // Inline function 'kotlin.collections.copyOf' call
    // Inline function 'kotlin.js.asDynamic' call
    var tmp$ret$1 = _Matrix___get_rowMajor__impl__vmgxkq($this).slice();
    return _Matrix___init__impl__q3kp4w(tmp$ret$1);
  }
  function Matrix__get_impl_xogbpk($this, x, y) {
    return _Matrix___get_rowMajor__impl__vmgxkq($this)[imul(y, 3) + x | 0];
  }
  function Matrix__set_impl_s2l54c($this, x, y, value) {
    _Matrix___get_rowMajor__impl__vmgxkq($this)[imul(y, 3) + x | 0] = value;
  }
  function Matrix__set_impl_s2l54c_0($this, x, y, value) {
    return Matrix__set_impl_s2l54c($this, x, y, value);
  }
  function Matrix__toString_impl_l0abk0($this) {
    return trimMargin('Mat3(\n        |   ' + Matrix__get_impl_xogbpk($this, 0, 0) + ', ' + Matrix__get_impl_xogbpk($this, 1, 0) + ', ' + Matrix__get_impl_xogbpk($this, 2, 0) + ', \n        |   ' + Matrix__get_impl_xogbpk($this, 0, 1) + ', ' + Matrix__get_impl_xogbpk($this, 1, 1) + ', ' + Matrix__get_impl_xogbpk($this, 2, 1) + ', \n        |   ' + Matrix__get_impl_xogbpk($this, 0, 2) + ', ' + Matrix__get_impl_xogbpk($this, 1, 2) + ', ' + Matrix__get_impl_xogbpk($this, 2, 2) + ', \n        |)\n        ');
  }
  function Matrix__hashCode_impl_s9ntm9($this) {
    return hashCode($this);
  }
  function Matrix__equals_impl_g5p8p9($this, other) {
    if (!(other instanceof Matrix))
      return false;
    var tmp0_other_with_cast = other instanceof Matrix ? other.g26_1 : THROW_CCE();
    if (!equals($this, tmp0_other_with_cast))
      return false;
    return true;
  }
  function Matrix(rowMajor) {
    this.g26_1 = rowMajor;
  }
  protoOf(Matrix).toString = function () {
    return Matrix__toString_impl_l0abk0(this.g26_1);
  };
  protoOf(Matrix).hashCode = function () {
    return Matrix__hashCode_impl_s9ntm9(this.g26_1);
  };
  protoOf(Matrix).equals = function (other) {
    return Matrix__equals_impl_g5p8p9(this.g26_1, other);
  };
  function inverse(_this__u8e3s4, inPlace) {
    inPlace = inPlace === VOID ? false : inPlace;
    var a = Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 0);
    var b = Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 0);
    var c = Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 0);
    var d = Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 1);
    var e = Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 1);
    var f = Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 1);
    var g = Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 2);
    var h = Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 2);
    var i = Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 2);
    var A = e * i - h * f;
    var B = h * c - b * i;
    var C = b * f - e * c;
    var det = a * A + d * B + g * C;
    var out = inPlace ? _this__u8e3s4 : Matrix__copy_impl_kmkvzd(_this__u8e3s4);
    Matrix__set_impl_s2l54c_0(out, 0, 0, A / det);
    Matrix__set_impl_s2l54c_0(out, 0, 1, (g * f - d * i) / det);
    Matrix__set_impl_s2l54c_0(out, 0, 2, (d * h - g * e) / det);
    Matrix__set_impl_s2l54c_0(out, 1, 0, B / det);
    Matrix__set_impl_s2l54c_0(out, 1, 1, (a * i - g * c) / det);
    Matrix__set_impl_s2l54c_0(out, 1, 2, (g * b - a * h) / det);
    Matrix__set_impl_s2l54c_0(out, 2, 0, C / det);
    Matrix__set_impl_s2l54c_0(out, 2, 1, (d * c - a * f) / det);
    Matrix__set_impl_s2l54c_0(out, 2, 2, (a * e - d * b) / det);
    return out;
  }
  function scalarDiv(_this__u8e3s4, x, inPlace) {
    inPlace = inPlace === VOID ? false : inPlace;
    var out = _Matrix___get_rowMajor__impl__vmgxkq(inPlace ? _this__u8e3s4 : Matrix__copy_impl_kmkvzd(_this__u8e3s4));
    var inductionVariable = 0;
    var last = out.length - 1 | 0;
    if (inductionVariable <= last)
      do {
        var i = inductionVariable;
        inductionVariable = inductionVariable + 1 | 0;
        out[i] = out[i] / x;
      }
       while (inductionVariable <= last);
    return _Matrix___init__impl__q3kp4w(out);
  }
  function dot(_this__u8e3s4, other) {
    return _Matrix___init__impl__q3kp4w_0(dot$f(_this__u8e3s4, other, 0, 0), dot$f(_this__u8e3s4, other, 1, 0), dot$f(_this__u8e3s4, other, 2, 0), dot$f(_this__u8e3s4, other, 0, 1), dot$f(_this__u8e3s4, other, 1, 1), dot$f(_this__u8e3s4, other, 2, 1), dot$f(_this__u8e3s4, other, 0, 2), dot$f(_this__u8e3s4, other, 1, 2), dot$f(_this__u8e3s4, other, 2, 2));
  }
  function dotDiagonal(_this__u8e3s4, v0, v1, v2) {
    return _Matrix___init__impl__q3kp4w_0(Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 0) * v0, Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 0) * v1, Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 0) * v2, Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 1) * v0, Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 1) * v1, Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 1) * v2, Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 2) * v0, Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 2) * v1, Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 2) * v2);
  }
  function _Vector___init__impl__y7x4qq(values) {
    return values;
  }
  function _Vector___get_values__impl__3gdbp5($this) {
    return $this;
  }
  function _Vector___init__impl__y7x4qq_0(v0, v1, v2) {
    // Inline function 'kotlin.floatArrayOf' call
    var tmp$ret$0 = new Float32Array([v0, v1, v2]);
    return _Vector___init__impl__y7x4qq(tmp$ret$0);
  }
  function _Vector___get_l__impl__envr1l($this) {
    return _Vector___get_values__impl__3gdbp5($this)[0];
  }
  function _Vector___get_m__impl__e5qq0m($this) {
    return _Vector___get_values__impl__3gdbp5($this)[1];
  }
  function _Vector___get_s__impl__pzuljk($this) {
    return _Vector___get_values__impl__3gdbp5($this)[2];
  }
  function dot_0(_this__u8e3s4, v0, v1, v2) {
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var p0 = Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 0) * v0 + Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 0) * v1 + Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 0) * v2;
    var p1 = Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 1) * v0 + Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 1) * v1 + Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 1) * v2;
    var p2 = Matrix__get_impl_xogbpk(_this__u8e3s4, 0, 2) * v0 + Matrix__get_impl_xogbpk(_this__u8e3s4, 1, 2) * v1 + Matrix__get_impl_xogbpk(_this__u8e3s4, 2, 2) * v2;
    return _Vector___init__impl__y7x4qq_0(p0, p1, p2);
  }
  function dot$f($this_dot, $other, x, y) {
    return Matrix__get_impl_xogbpk($this_dot, 0, y) * Matrix__get_impl_xogbpk($other, x, 0) + Matrix__get_impl_xogbpk($this_dot, 1, y) * Matrix__get_impl_xogbpk($other, x, 1) + Matrix__get_impl_xogbpk($this_dot, 2, y) * Matrix__get_impl_xogbpk($other, x, 2);
  }
  function Companion() {
    Companion_instance = this;
    this.h26_1 = componentInfoList([new ColorComponentInfo('code', false, 30.0, 107.0)]);
  }
  protoOf(Companion).i26 = function () {
    return this.h26_1;
  };
  var Companion_instance;
  function Companion_getInstance() {
    if (Companion_instance == null)
      new Companion();
    return Companion_instance;
  }
  function Ansi16(code) {
    Companion_getInstance();
    this.j26_1 = code;
  }
  protoOf(Ansi16).k25 = function () {
    return Companion_getInstance();
  };
  protoOf(Ansi16).l25 = function () {
    switch (this.j26_1) {
      case 30:
      case 40:
        return Companion_getInstance_2().k26(0.0, 0.0, 0.0);
      case 90:
      case 100:
        return Companion_getInstance_2().l26(128, 128, 128);
      case 37:
      case 47:
        return Companion_getInstance_2().l26(192, 192, 192);
      case 97:
      case 107:
        return Companion_getInstance_2().k26(1.0, 1.0, 1.0);
    }
    var color = this.j26_1 % 10 | 0;
    var mul = this.j26_1 > 50 ? 1.0 : 0.5;
    var r = (color % 2 | 0) * mul;
    var g = ((color / 2 | 0) % 2 | 0) * mul;
    var b = ((color / 4 | 0) % 2 | 0) * mul;
    return Companion_getInstance_2().k26(r, g, b);
  };
  protoOf(Ansi16).toString = function () {
    return 'Ansi16(code=' + this.j26_1 + ')';
  };
  protoOf(Ansi16).hashCode = function () {
    return this.j26_1;
  };
  protoOf(Ansi16).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof Ansi16))
      return false;
    var tmp0_other_with_cast = other instanceof Ansi16 ? other : THROW_CCE();
    if (!(this.j26_1 === tmp0_other_with_cast.j26_1))
      return false;
    return true;
  };
  function Companion_0() {
    Companion_instance_0 = this;
    this.m26_1 = componentInfoList([new ColorComponentInfo('code', false, 0.0, 255.0)]);
  }
  protoOf(Companion_0).i26 = function () {
    return this.m26_1;
  };
  var Companion_instance_0;
  function Companion_getInstance_0() {
    if (Companion_instance_0 == null)
      new Companion_0();
    return Companion_instance_0;
  }
  function Ansi256(code) {
    Companion_getInstance_0();
    this.n26_1 = code;
  }
  protoOf(Ansi256).k25 = function () {
    return Companion_getInstance_0();
  };
  protoOf(Ansi256).l25 = function () {
    if (this.n26_1 < 16)
      return this.o26().l25();
    if (this.n26_1 >= 232) {
      var c = imul(this.n26_1 - 232 | 0, 10) + 8 | 0;
      return Companion_getInstance_2().l26(c, c, c);
    }
    var c_0 = this.n26_1 - 16 | 0;
    var rem = c_0 % 36 | 0;
    // Inline function 'kotlin.math.floor' call
    var x = c_0 / 36.0;
    var r = Math.floor(x) / 5.0;
    // Inline function 'kotlin.math.floor' call
    var x_0 = rem / 6.0;
    var g = Math.floor(x_0) / 5.0;
    var b = (rem % 6 | 0) / 5.0;
    return Companion_getInstance_2().p26(r, g, b);
  };
  protoOf(Ansi256).o26 = function () {
    return this.n26_1 < 8 ? new Ansi16(this.n26_1 + 30 | 0) : this.n26_1 < 16 ? new Ansi16((this.n26_1 - 8 | 0) + 90 | 0) : this.l25().o26();
  };
  protoOf(Ansi256).toString = function () {
    return 'Ansi256(code=' + this.n26_1 + ')';
  };
  protoOf(Ansi256).hashCode = function () {
    return this.n26_1;
  };
  protoOf(Ansi256).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof Ansi256))
      return false;
    var tmp0_other_with_cast = other instanceof Ansi256 ? other : THROW_CCE();
    if (!(this.n26_1 === tmp0_other_with_cast.n26_1))
      return false;
    return true;
  };
  function Companion_1() {
    Companion_instance_1 = this;
    this.q26_1 = polarComponentInfo('HSV', 0.0, 1.0);
  }
  protoOf(Companion_1).i26 = function () {
    return this.q26_1;
  };
  var Companion_instance_1;
  function Companion_getInstance_1() {
    if (Companion_instance_1 == null)
      new Companion_1();
    return Companion_instance_1;
  }
  function toSRGB$f(h, v, s, n) {
    var k = (n + h) % 6;
    var tmp = v * s;
    // Inline function 'kotlin.comparisons.minOf' call
    var b = 4 - k;
    var tmp$ret$0 = Math.min(k, b, 1.0);
    return v - tmp * coerceAtLeast(tmp$ret$0, 0.0);
  }
  function HSV(h, s, v, alpha) {
    Companion_getInstance_1();
    alpha = alpha === VOID ? 1.0 : alpha;
    this.r26_1 = h;
    this.s26_1 = s;
    this.t26_1 = v;
    this.u26_1 = alpha;
  }
  protoOf(HSV).k25 = function () {
    return Companion_getInstance_1();
  };
  protoOf(HSV).l25 = function () {
    if (this.s26_1 < 1.0E-7)
      return Companion_getInstance_2().w26(this.t26_1, this.t26_1, this.t26_1, this.u26_1);
    var v = this.t26_1;
    var h = normalizeDeg_0(this.r26_1) / 60.0;
    var s = this.s26_1;
    return SRGB_getInstance().w26(toSRGB$f(h, v, s, 5), toSRGB$f(h, v, s, 3), toSRGB$f(h, v, s, 1), this.u26_1);
  };
  protoOf(HSV).toString = function () {
    return 'HSV(h=' + this.r26_1 + ', s=' + this.s26_1 + ', v=' + this.t26_1 + ', alpha=' + this.u26_1 + ')';
  };
  protoOf(HSV).hashCode = function () {
    var result = getNumberHashCode(this.r26_1);
    result = imul(result, 31) + getNumberHashCode(this.s26_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.t26_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.u26_1) | 0;
    return result;
  };
  protoOf(HSV).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof HSV))
      return false;
    var tmp0_other_with_cast = other instanceof HSV ? other : THROW_CCE();
    if (!equals(this.r26_1, tmp0_other_with_cast.r26_1))
      return false;
    if (!equals(this.s26_1, tmp0_other_with_cast.s26_1))
      return false;
    if (!equals(this.t26_1, tmp0_other_with_cast.t26_1))
      return false;
    if (!equals(this.u26_1, tmp0_other_with_cast.u26_1))
      return false;
    return true;
  };
  function get_ICTCP_RGB_TO_LMS() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_RGB_TO_LMS;
  }
  var ICTCP_RGB_TO_LMS;
  function get_ICTCP_LMS_TO_ICTCP() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_LMS_TO_ICTCP;
  }
  var ICTCP_LMS_TO_ICTCP;
  function get_ICTCP_LMS_to_RGB() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_LMS_to_RGB;
  }
  var ICTCP_LMS_to_RGB;
  function get_ICTCP_ICTCP_to_LMS() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_ICTCP_to_LMS;
  }
  var ICTCP_ICTCP_to_LMS;
  function get_ICTCP_CROSSTALK() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_CROSSTALK;
  }
  var ICTCP_CROSSTALK;
  function get_HPE_XYZ_TO_LMS() {
    _init_properties_ICtCp_kt__7vx7or();
    return HPE_XYZ_TO_LMS;
  }
  var HPE_XYZ_TO_LMS;
  function get_ICTCP_XYZ_TO_LMS() {
    _init_properties_ICtCp_kt__7vx7or();
    return ICTCP_XYZ_TO_LMS;
  }
  var ICTCP_XYZ_TO_LMS;
  var ICTCP_LMS_TO_XYZ;
  function ICtCp() {
  }
  protoOf(ICtCp).c27 = function () {
    var fo = RGBColorSpaces_getInstance().k27_1.p27();
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var this_0 = get_ICTCP_ICTCP_to_LMS();
    var v0 = this.y26_1;
    var v1 = this.z26_1;
    var v2 = this.a27_1;
    // Inline function 'com.github.ajalt.colormath.model.ICtCp.toBT2020.<anonymous>' call
    var l = Matrix__get_impl_xogbpk(this_0, 0, 0) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 0) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 0) * v2;
    var m = Matrix__get_impl_xogbpk(this_0, 0, 1) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 1) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 1) * v2;
    var s = Matrix__get_impl_xogbpk(this_0, 0, 2) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 2) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 2) * v2;
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var this_1 = get_ICTCP_LMS_to_RGB();
    var v0_0 = PqNonlinearity_instance.y27(l);
    var v1_0 = PqNonlinearity_instance.y27(m);
    var v2_0 = PqNonlinearity_instance.y27(s);
    // Inline function 'com.github.ajalt.colormath.model.ICtCp.toBT2020.<anonymous>.<anonymous>' call
    var r = Matrix__get_impl_xogbpk(this_1, 0, 0) * v0_0 + Matrix__get_impl_xogbpk(this_1, 1, 0) * v1_0 + Matrix__get_impl_xogbpk(this_1, 2, 0) * v2_0;
    var g = Matrix__get_impl_xogbpk(this_1, 0, 1) * v0_0 + Matrix__get_impl_xogbpk(this_1, 1, 1) * v1_0 + Matrix__get_impl_xogbpk(this_1, 2, 1) * v2_0;
    var b = Matrix__get_impl_xogbpk(this_1, 0, 2) * v0_0 + Matrix__get_impl_xogbpk(this_1, 1, 2) * v1_0 + Matrix__get_impl_xogbpk(this_1, 2, 2) * v2_0;
    return RGBColorSpaces_getInstance().k27_1.w26(fo.z27(r), fo.z27(g), fo.z27(b), this.b27_1);
  };
  function PqNonlinearity() {
    this.q27_1 = 0.1593017578125;
    this.r27_1 = 78.84375;
    this.s27_1 = 0.8359375;
    this.t27_1 = 18.8515625;
    this.u27_1 = 18.6875;
    this.v27_1 = 10000.0;
    this.w27_1 = 6.277394636015326;
    this.x27_1 = 0.012683313515655966;
  }
  protoOf(PqNonlinearity).y27 = function (x) {
    var vp = spow(x, 0.012683313515655966);
    var n = coerceAtLeast(vp - 0.8359375, 0.0);
    var l = spow_0(n / (18.8515625 - 18.6875 * vp), 6.277394636015326);
    return 10000.0 * l;
  };
  protoOf(PqNonlinearity).z27 = function (x) {
    var yp = spow_0(x / 10000.0, 0.1593017578125);
    return spow_0((0.8359375 + 18.8515625 * yp) / (1.0 + 18.6875 * yp), 78.84375);
  };
  var PqNonlinearity_instance;
  function PqNonlinearity_getInstance() {
    return PqNonlinearity_instance;
  }
  var properties_initialized_ICtCp_kt_w6y8uv;
  function _init_properties_ICtCp_kt__7vx7or() {
    if (!properties_initialized_ICtCp_kt_w6y8uv) {
      properties_initialized_ICtCp_kt_w6y8uv = true;
      ICTCP_RGB_TO_LMS = scalarDiv(_Matrix___init__impl__q3kp4w_0(1688.0, 2146.0, 262.0, 683.0, 2951.0, 462.0, 99.0, 309.0, 3688.0), 4096.0, true);
      ICTCP_LMS_TO_ICTCP = scalarDiv(_Matrix___init__impl__q3kp4w_0(2048.0, 2048.0, 0.0, 6610.0, -13613.0, 7003.0, 17933.0, -17390.0, -543.0), 4096.0, true);
      ICTCP_LMS_to_RGB = inverse(get_ICTCP_RGB_TO_LMS());
      ICTCP_ICTCP_to_LMS = inverse(get_ICTCP_LMS_TO_ICTCP());
      ICTCP_CROSSTALK = _Matrix___init__impl__q3kp4w_0(0.92, 0.04, 0.04, 0.04, 0.92, 0.04, 0.04, 0.04, 0.92);
      HPE_XYZ_TO_LMS = _Matrix___init__impl__q3kp4w_0(0.4002, 0.7076, -0.0808, -0.2263, 1.1653, 0.0457, 0.0, 0.0, 0.9182);
      ICTCP_XYZ_TO_LMS = dot(get_ICTCP_CROSSTALK(), get_HPE_XYZ_TO_LMS());
      ICTCP_LMS_TO_XYZ = inverse(get_ICTCP_XYZ_TO_LMS());
    }
  }
  function GammaTransferFunctions(gamma) {
    this.a28_1 = gamma;
  }
  protoOf(GammaTransferFunctions).y27 = function (x) {
    return spow(x, this.a28_1);
  };
  protoOf(GammaTransferFunctions).z27 = function (x) {
    return spow(x, 1.0 / this.a28_1);
  };
  protoOf(GammaTransferFunctions).toString = function () {
    return 'GammaTransferFunctions(gamma=' + this.a28_1 + ')';
  };
  protoOf(GammaTransferFunctions).hashCode = function () {
    return getNumberHashCode(this.a28_1);
  };
  protoOf(GammaTransferFunctions).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof GammaTransferFunctions))
      return false;
    var tmp0_other_with_cast = other instanceof GammaTransferFunctions ? other : THROW_CCE();
    if (!equals(this.a28_1, tmp0_other_with_cast.a28_1))
      return false;
    return true;
  };
  function LinearTransferFunctions() {
  }
  protoOf(LinearTransferFunctions).y27 = function (x) {
    return x;
  };
  protoOf(LinearTransferFunctions).z27 = function (x) {
    return x;
  };
  var LinearTransferFunctions_instance;
  function LinearTransferFunctions_getInstance() {
    return LinearTransferFunctions_instance;
  }
  function RGBColorSpace() {
  }
  function Companion_2() {
    Companion_instance_2 = this;
    this.v26_1 = RGBColorSpaces_getInstance().d27_1;
  }
  protoOf(Companion_2).w26 = function (r, g, b, alpha) {
    return this.v26_1.w26(r, g, b, alpha);
  };
  protoOf(Companion_2).b28 = function (r, g, b, alpha) {
    return this.v26_1.b28(r, g, b, alpha);
  };
  protoOf(Companion_2).d28 = function (hex) {
    return this.v26_1.d28(hex);
  };
  protoOf(Companion_2).c28 = function (r, g, b, alpha) {
    return this.v26_1.c28(r, g, b, alpha);
  };
  protoOf(Companion_2).p27 = function () {
    return this.v26_1.p27();
  };
  protoOf(Companion_2).e28 = function () {
    return this.v26_1.e28();
  };
  protoOf(Companion_2).f28 = function () {
    return this.v26_1.f28();
  };
  protoOf(Companion_2).g28 = function () {
    return this.v26_1.g28();
  };
  protoOf(Companion_2).j1e = function () {
    return this.v26_1.j1e();
  };
  protoOf(Companion_2).i26 = function () {
    return this.v26_1.i26();
  };
  protoOf(Companion_2).equals = function (other) {
    return equals(RGBColorSpaces_getInstance().d27_1, other);
  };
  protoOf(Companion_2).hashCode = function () {
    return hashCode(RGBColorSpaces_getInstance().d27_1);
  };
  var Companion_instance_2;
  function Companion_getInstance_2() {
    if (Companion_instance_2 == null)
      new Companion_2();
    return Companion_instance_2;
  }
  function clamp$copy(receiver, p0, p1, p2, p3) {
    return receiver.h28(p0, p1, p2, p3);
  }
  function RGB(r, g, b, alpha, space) {
    Companion_getInstance_2();
    this.n25_1 = r;
    this.o25_1 = g;
    this.p25_1 = b;
    this.q25_1 = alpha;
    this.r25_1 = space;
  }
  protoOf(RGB).k25 = function () {
    return this.r25_1;
  };
  protoOf(RGB).i28 = function () {
    // Inline function 'kotlin.math.roundToInt' call
    var this_0 = this.n25_1 * 255;
    return roundToInt(this_0);
  };
  protoOf(RGB).j28 = function () {
    // Inline function 'kotlin.math.roundToInt' call
    var this_0 = this.o25_1 * 255;
    return roundToInt(this_0);
  };
  protoOf(RGB).k28 = function () {
    // Inline function 'kotlin.math.roundToInt' call
    var this_0 = this.p25_1 * 255;
    return roundToInt(this_0);
  };
  protoOf(RGB).l28 = function (space) {
    var f = SRGB_getInstance().p27();
    return equals(this.r25_1, space) ? this : equals(this.r25_1, SRGB_getInstance()) && equals(space, RGBColorSpaces_getInstance().e27_1) ? space.w26(f.y27(this.n25_1), f.y27(this.o25_1), f.y27(this.p25_1), this.q25_1) : equals(this.r25_1, RGBColorSpaces_getInstance().e27_1) && equals(space, SRGB_getInstance()) ? space.w26(f.z27(this.n25_1), f.z27(this.o25_1), f.z27(this.p25_1), this.q25_1) : this.m25().r28(space);
  };
  protoOf(RGB).s28 = function () {
    var tmp$ret$3;
    $l$block: {
      // Inline function 'com.github.ajalt.colormath.model.RGB.srgbHueMinMaxChroma' call
      // Inline function 'com.github.ajalt.colormath.model.RGB.toSRGB' call
      var $this$toSRGB = this.l28(SRGB_getInstance());
      var r = $this$toSRGB.n25_1;
      var g = $this$toSRGB.o25_1;
      var b = $this$toSRGB.p25_1;
      // Inline function 'kotlin.comparisons.minOf' call
      var min = Math.min(r, g, b);
      // Inline function 'kotlin.comparisons.maxOf' call
      var max = Math.max(r, g, b);
      var chroma = max - min;
      var h = (chroma < 1.0E-7 ? NaN : r === max ? (g - b) / chroma : g === max ? 2 + (b - r) / chroma : b === max ? 4 + (r - g) / chroma : 0.0) * 60;
      // Inline function 'com.github.ajalt.colormath.model.RGB.toHSV.<anonymous>' call
      var h_0 = normalizeDeg(h);
      var s = max === 0.0 ? 0.0 : chroma / max;
      tmp$ret$3 = new HSV(h_0, s, max, this.q25_1);
      break $l$block;
    }
    return tmp$ret$3;
  };
  protoOf(RGB).m25 = function () {
    var f = this.r25_1.p27();
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var this_0 = _Matrix___init__impl__q3kp4w(this.r25_1.e28());
    var v0 = f.y27(this.n25_1);
    var v1 = f.y27(this.o25_1);
    var v2 = f.y27(this.p25_1);
    // Inline function 'com.github.ajalt.colormath.model.RGB.toXYZ.<anonymous>' call
    var x = Matrix__get_impl_xogbpk(this_0, 0, 0) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 0) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 0) * v2;
    var y = Matrix__get_impl_xogbpk(this_0, 0, 1) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 1) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 1) * v2;
    var z = Matrix__get_impl_xogbpk(this_0, 0, 2) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 2) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 2) * v2;
    return XYZColorSpace_0(this.r25_1.g28()).w26(x, y, z, this.q25_1);
  };
  protoOf(RGB).o26 = function () {
    // Inline function 'com.github.ajalt.colormath.model.RGB.toSRGB' call
    var $this$toSRGB = this.l28(SRGB_getInstance());
    // Inline function 'kotlin.math.roundToInt' call
    var this_0 = $this$toSRGB.s28().t26_1 * 100;
    var value = roundToInt(this_0);
    if (value === 30)
      return new Ansi16(30);
    var v = value / 50 | 0;
    // Inline function 'kotlin.math.roundToInt' call
    var this_1 = $this$toSRGB.p25_1;
    var tmp$ret$1 = roundToInt(this_1);
    var tmp = imul(tmp$ret$1, 4);
    // Inline function 'kotlin.math.roundToInt' call
    var this_2 = $this$toSRGB.o25_1;
    var tmp$ret$2 = roundToInt(this_2);
    var tmp_0 = tmp | imul(tmp$ret$2, 2);
    // Inline function 'kotlin.math.roundToInt' call
    var this_3 = $this$toSRGB.n25_1;
    var ansi = 30 + (tmp_0 | roundToInt(this_3)) | 0;
    return new Ansi16(v === 2 ? ansi + 60 | 0 : ansi);
  };
  protoOf(RGB).t28 = function () {
    // Inline function 'com.github.ajalt.colormath.model.RGB.toSRGB' call
    var $this$toSRGB = this.l28(SRGB_getInstance());
    var ri = $this$toSRGB.i28();
    var gi = $this$toSRGB.j28();
    var bi = $this$toSRGB.k28();
    var tmp;
    if (ri === gi && gi === bi) {
      tmp = ri < 8 ? 16 : ri > 248 ? 231 : roundToInt((ri - 8 | 0) / 247.0 * 24.0) + 232 | 0;
    } else {
      // Inline function 'kotlin.math.roundToInt' call
      var this_0 = $this$toSRGB.n25_1 * 5;
      var tmp$ret$0 = roundToInt(this_0);
      var tmp_0 = 16 + imul(36, tmp$ret$0) | 0;
      // Inline function 'kotlin.math.roundToInt' call
      var this_1 = $this$toSRGB.o25_1 * 5;
      var tmp$ret$1 = roundToInt(this_1);
      var tmp_1 = tmp_0 + imul(6, tmp$ret$1) | 0;
      // Inline function 'kotlin.math.roundToInt' call
      var this_2 = $this$toSRGB.p25_1 * 5;
      tmp = tmp_1 + roundToInt(this_2) | 0;
    }
    var code = tmp;
    return new Ansi256(code);
  };
  protoOf(RGB).l25 = function () {
    return this.l28(RGBColorSpaces_getInstance().d27_1);
  };
  protoOf(RGB).u28 = function () {
    // Inline function 'com.github.ajalt.colormath.internal.clamp3' call
    var v1 = this.n25_1;
    var v2 = this.o25_1;
    var v3 = this.p25_1;
    var alpha = this.q25_1;
    var _destruct__k2r9zo = this.k25().i26();
    // Inline function 'kotlin.collections.component1' call
    var c1 = _destruct__k2r9zo.q(0);
    // Inline function 'kotlin.collections.component2' call
    var c2 = _destruct__k2r9zo.q(1);
    // Inline function 'kotlin.collections.component3' call
    var c3 = _destruct__k2r9zo.q(2);
    var tmp;
    var tmp_0;
    var tmp_1;
    var tmp_2;
    var containsLower = c1.u25_1;
    if (v1 <= c1.v25_1 ? containsLower <= v1 : false) {
      var containsLower_0 = c2.u25_1;
      tmp_2 = v2 <= c2.v25_1 ? containsLower_0 <= v2 : false;
    } else {
      tmp_2 = false;
    }
    if (tmp_2) {
      var containsLower_1 = c3.u25_1;
      tmp_1 = v3 <= c3.v25_1 ? containsLower_1 <= v3 : false;
    } else {
      tmp_1 = false;
    }
    if (tmp_1) {
      tmp_0 = 0.0 <= alpha ? alpha <= 1.0 : false;
    } else {
      tmp_0 = false;
    }
    if (tmp_0) {
      tmp = this;
    } else {
      tmp = clamp$copy(this, coerceIn(v1, c1.u25_1, c1.v25_1), coerceIn(v2, c2.u25_1, c2.v25_1), coerceIn(v3, c3.u25_1, c3.v25_1), coerceIn(alpha, 0.0, 1.0));
    }
    return tmp;
  };
  protoOf(RGB).v28 = function (r, g, b, alpha, space) {
    return new RGB(r, g, b, alpha, space);
  };
  protoOf(RGB).h28 = function (r, g, b, alpha, space, $super) {
    r = r === VOID ? this.n25_1 : r;
    g = g === VOID ? this.o25_1 : g;
    b = b === VOID ? this.p25_1 : b;
    alpha = alpha === VOID ? this.q25_1 : alpha;
    space = space === VOID ? this.r25_1 : space;
    return $super === VOID ? this.v28(r, g, b, alpha, space) : $super.v28.call(this, r, g, b, alpha, space);
  };
  protoOf(RGB).toString = function () {
    return 'RGB(r=' + this.n25_1 + ', g=' + this.o25_1 + ', b=' + this.p25_1 + ', alpha=' + this.q25_1 + ', space=' + toString(this.r25_1) + ')';
  };
  protoOf(RGB).hashCode = function () {
    var result = getNumberHashCode(this.n25_1);
    result = imul(result, 31) + getNumberHashCode(this.o25_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.p25_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.q25_1) | 0;
    result = imul(result, 31) + hashCode(this.r25_1) | 0;
    return result;
  };
  protoOf(RGB).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof RGB))
      return false;
    var tmp0_other_with_cast = other instanceof RGB ? other : THROW_CCE();
    if (!equals(this.n25_1, tmp0_other_with_cast.n25_1))
      return false;
    if (!equals(this.o25_1, tmp0_other_with_cast.o25_1))
      return false;
    if (!equals(this.p25_1, tmp0_other_with_cast.p25_1))
      return false;
    if (!equals(this.q25_1, tmp0_other_with_cast.q25_1))
      return false;
    if (!equals(this.r25_1, tmp0_other_with_cast.r25_1))
      return false;
    return true;
  };
  function parseHex(_this__u8e3s4, startIndex) {
    var tmp;
    if (get_hexLength(_this__u8e3s4) > 4) {
      var i = charSequenceGet(_this__u8e3s4, 0) === _Char___init__impl__6a9atx(35) ? imul(startIndex, 2) + 1 | 0 : imul(startIndex, 2);
      tmp = toInt(slice(_this__u8e3s4, numberRangeToNumber(i, i + 1 | 0)), 16);
    } else {
      var i_0 = charSequenceGet(_this__u8e3s4, 0) === _Char___init__impl__6a9atx(35) ? startIndex + 1 | 0 : startIndex;
      // Inline function 'kotlin.let' call
      // Inline function 'kotlin.contracts.contract' call
      // Inline function 'com.github.ajalt.colormath.model.parseHex.<anonymous>' call
      var it = charSequenceGet(_this__u8e3s4, i_0);
      var tmp$ret$1 = toString_0(it) + toString_0(it);
      tmp = toInt(tmp$ret$1, 16);
    }
    return tmp;
  }
  function validateHex(_this__u8e3s4) {
    // Inline function 'kotlin.apply' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.github.ajalt.colormath.model.validateHex.<anonymous>' call
    // Inline function 'kotlin.require' call
    // Inline function 'kotlin.let' call
    // Inline function 'kotlin.contracts.contract' call
    // Inline function 'com.github.ajalt.colormath.model.validateHex.<anonymous>.<anonymous>' call
    var it = get_hexLength(_this__u8e3s4);
    switch (it) {
      case 3:
      case 4:
      case 6:
        var tmp$ret$0 = true;
        break;
      default:
        tmp$ret$0 = it === 8;
        break;
    }
    // Inline function 'kotlin.contracts.contract' call
    if (!tmp$ret$0) {
      // Inline function 'com.github.ajalt.colormath.model.validateHex.<anonymous>.<anonymous>' call
      var message = 'Hex string must be in the format "#ffffff" or "ffffff"';
      throw IllegalArgumentException_init_$Create$(toString(message));
    }
    return _this__u8e3s4;
  }
  function get_hexLength(_this__u8e3s4) {
    return startsWith(_this__u8e3s4, '#') ? _this__u8e3s4.length - 1 | 0 : _this__u8e3s4.length;
  }
  function get_SRGB_R() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return SRGB_R;
  }
  var SRGB_R;
  function get_SRGB_G() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return SRGB_G;
  }
  var SRGB_G;
  function get_SRGB_B() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return SRGB_B;
  }
  var SRGB_B;
  function get_ACES_WHITE_POINT() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_WHITE_POINT;
  }
  var ACES_WHITE_POINT;
  function get_ACES_AP0_R() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP0_R;
  }
  var ACES_AP0_R;
  function get_ACES_AP0_G() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP0_G;
  }
  var ACES_AP0_G;
  function get_ACES_AP0_B() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP0_B;
  }
  var ACES_AP0_B;
  function get_ACES_AP1_R() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP1_R;
  }
  var ACES_AP1_R;
  function get_ACES_AP1_G() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP1_G;
  }
  var ACES_AP1_G;
  function get_ACES_AP1_B() {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return ACES_AP1_B;
  }
  var ACES_AP1_B;
  function RGBColorSpaces$SRGB$lambda($this$RGBColorSpaceImpl, it) {
    return it.l25();
  }
  function RGBColorSpaces$BT2020$lambda($this$RGBColorSpaceImpl, color) {
    var tmp;
    if (color instanceof RGB) {
      tmp = color.l28($this$RGBColorSpaceImpl);
    } else {
      if (color instanceof ICtCp) {
        tmp = color.c27();
      } else {
        tmp = color.m25().r28($this$RGBColorSpaceImpl);
      }
    }
    return tmp;
  }
  function RGBColorSpaces() {
    RGBColorSpaces_instance = this;
    var tmp = this;
    var tmp_0 = Illuminant_getInstance().d26_1;
    var tmp_1 = SRGBTransferFunctions_instance;
    var tmp_2 = get_SRGB_R();
    var tmp_3 = get_SRGB_G();
    var tmp_4 = get_SRGB_B();
    tmp.d27_1 = new RGBColorSpaceImpl('sRGB', tmp_0, tmp_1, tmp_2, tmp_3, tmp_4, RGBColorSpaces$SRGB$lambda);
    this.e27_1 = RGBColorSpace_0('Linear sRGB', Illuminant_getInstance().d26_1, LinearTransferFunctions_instance, get_SRGB_R(), get_SRGB_G(), get_SRGB_B());
    this.f27_1 = RGBColorSpace_0('ACES2065-1', get_ACES_WHITE_POINT(), LinearTransferFunctions_instance, get_ACES_AP0_R(), get_ACES_AP0_G(), get_ACES_AP0_B());
    this.g27_1 = RGBColorSpace_0('ACEScc', get_ACES_WHITE_POINT(), ACESccTransferFunctions_getInstance(), get_ACES_AP1_R(), get_ACES_AP1_G(), get_ACES_AP1_B());
    this.h27_1 = RGBColorSpace_0('ACEScct', get_ACES_WHITE_POINT(), ACEScctTransferFunctions_getInstance(), get_ACES_AP1_R(), get_ACES_AP1_G(), get_ACES_AP1_B());
    this.i27_1 = RGBColorSpace_0('ACEScg', get_ACES_WHITE_POINT(), LinearTransferFunctions_instance, get_ACES_AP1_R(), get_ACES_AP1_G(), get_ACES_AP1_B());
    this.j27_1 = RGBColorSpace_0('Adobe RGB', Illuminant_getInstance().d26_1, new GammaTransferFunctions(2.19921875), xyY_init_$Create$(0.64, 0.33), xyY_init_$Create$(0.21, 0.71), xyY_init_$Create$(0.15, 0.06));
    var tmp_5 = this;
    var tmp_6 = Illuminant_getInstance().d26_1;
    var tmp_7 = BT2020TransferFunctions_getInstance();
    var tmp_8 = xyY_init_$Create$(0.708, 0.292);
    var tmp_9 = xyY_init_$Create$(0.17, 0.797);
    var tmp_10 = xyY_init_$Create$(0.131, 0.046);
    tmp_5.k27_1 = new RGBColorSpaceImpl('BT.2020', tmp_6, tmp_7, tmp_8, tmp_9, tmp_10, RGBColorSpaces$BT2020$lambda);
    this.l27_1 = RGBColorSpace_0('BT.709', Illuminant_getInstance().d26_1, BT709TransferFunctions_getInstance(), xyY_init_$Create$(0.64, 0.33), xyY_init_$Create$(0.3, 0.6), xyY_init_$Create$(0.15, 0.06));
    this.m27_1 = RGBColorSpace_0('DCI P3', new WhitePoint('DCI P3', xyY_init_$Create$(0.314, 0.351)), new GammaTransferFunctions(2.6), xyY_init_$Create$(0.68, 0.32), xyY_init_$Create$(0.265, 0.69), xyY_init_$Create$(0.15, 0.06));
    this.n27_1 = RGBColorSpace_0('Display P3', Illuminant_getInstance().d26_1, SRGBTransferFunctions_instance, xyY_init_$Create$(0.68, 0.32), xyY_init_$Create$(0.265, 0.69), xyY_init_$Create$(0.15, 0.06));
    this.o27_1 = RGBColorSpace_0('ROMM RGB', Illuminant_getInstance().b26_1, ROMMTransferFunctions_instance, xyY_init_$Create$(0.7347, 0.2653), xyY_init_$Create$(0.1596, 0.8404), xyY_init_$Create$(0.0366, 1.0E-4));
  }
  var RGBColorSpaces_instance;
  function RGBColorSpaces_getInstance() {
    if (RGBColorSpaces_instance == null)
      new RGBColorSpaces();
    return RGBColorSpaces_instance;
  }
  function SRGB() {
    SRGB_instance = this;
    this.x26_1 = RGBColorSpaces_getInstance().d27_1;
  }
  protoOf(SRGB).w26 = function (r, g, b, alpha) {
    return this.x26_1.w26(r, g, b, alpha);
  };
  protoOf(SRGB).b28 = function (r, g, b, alpha) {
    return this.x26_1.b28(r, g, b, alpha);
  };
  protoOf(SRGB).d28 = function (hex) {
    return this.x26_1.d28(hex);
  };
  protoOf(SRGB).c28 = function (r, g, b, alpha) {
    return this.x26_1.c28(r, g, b, alpha);
  };
  protoOf(SRGB).p27 = function () {
    return this.x26_1.p27();
  };
  protoOf(SRGB).e28 = function () {
    return this.x26_1.e28();
  };
  protoOf(SRGB).f28 = function () {
    return this.x26_1.f28();
  };
  protoOf(SRGB).g28 = function () {
    return this.x26_1.g28();
  };
  protoOf(SRGB).j1e = function () {
    return this.x26_1.j1e();
  };
  protoOf(SRGB).i26 = function () {
    return this.x26_1.i26();
  };
  protoOf(SRGB).equals = function (other) {
    return equals(RGBColorSpaces_getInstance().d27_1, other);
  };
  protoOf(SRGB).hashCode = function () {
    return hashCode(RGBColorSpaces_getInstance().d27_1);
  };
  protoOf(SRGB).toString = function () {
    return 'sRGB';
  };
  var SRGB_instance;
  function SRGB_getInstance() {
    if (SRGB_instance == null)
      new SRGB();
    return SRGB_instance;
  }
  function RGBColorSpaceImpl(name, whitePoint, transferFunctions, r, g, b, convertImpl) {
    this.w28_1 = name;
    this.x28_1 = whitePoint;
    this.y28_1 = transferFunctions;
    this.z28_1 = r;
    this.a29_1 = g;
    this.b29_1 = b;
    this.c29_1 = convertImpl;
    this.d29_1 = zeroOneComponentInfo('RGB');
    this.e29_1 = _Matrix___get_rowMajor__impl__vmgxkq(rgbToXyzMatrix(this.x28_1, this.z28_1, this.a29_1, this.b29_1));
    this.f29_1 = _Matrix___get_rowMajor__impl__vmgxkq(inverse(_Matrix___init__impl__q3kp4w(this.e29_1)));
  }
  protoOf(RGBColorSpaceImpl).j1e = function () {
    return this.w28_1;
  };
  protoOf(RGBColorSpaceImpl).g28 = function () {
    return this.x28_1;
  };
  protoOf(RGBColorSpaceImpl).p27 = function () {
    return this.y28_1;
  };
  protoOf(RGBColorSpaceImpl).i26 = function () {
    return this.d29_1;
  };
  protoOf(RGBColorSpaceImpl).e28 = function () {
    return this.e29_1;
  };
  protoOf(RGBColorSpaceImpl).f28 = function () {
    return this.f29_1;
  };
  protoOf(RGBColorSpaceImpl).toString = function () {
    return this.w28_1;
  };
  protoOf(RGBColorSpaceImpl).w26 = function (r, g, b, alpha) {
    return new RGB(r, g, b, alpha, this);
  };
  protoOf(RGBColorSpaceImpl).equals = function (other) {
    if (this === other)
      return true;
    if (!(!(other == null) ? isInterface(other, RGBColorSpace) : false))
      return false;
    if (!(this.w28_1 === other.j1e()))
      return false;
    if (!this.x28_1.equals(other.g28()))
      return false;
    if (!equals(this.y28_1, other.p27()))
      return false;
    if (other instanceof RGBColorSpaceImpl) {
      if (!this.z28_1.equals(other.z28_1))
        return false;
      if (!this.a29_1.equals(other.a29_1))
        return false;
      if (!this.b29_1.equals(other.b29_1))
        return false;
    } else {
      if (!contentEquals(this.e29_1, other.e28()))
        return false;
      if (!contentEquals(this.f29_1, other.f28()))
        return false;
    }
    return true;
  };
  protoOf(RGBColorSpaceImpl).hashCode = function () {
    var result = getStringHashCode(this.w28_1);
    result = imul(31, result) + this.x28_1.hashCode() | 0;
    result = imul(31, result) + hashCode(this.y28_1) | 0;
    result = imul(31, result) + this.z28_1.hashCode() | 0;
    result = imul(31, result) + this.a29_1.hashCode() | 0;
    result = imul(31, result) + this.b29_1.hashCode() | 0;
    return result;
  };
  function SRGBTransferFunctions() {
  }
  protoOf(SRGBTransferFunctions).z27 = function (x) {
    return x <= 0.0031308 ? x * 12.92 : 1.055 * spow(x, 1 / 2.4) - 0.055;
  };
  protoOf(SRGBTransferFunctions).y27 = function (x) {
    return x <= 0.04045 ? x / 12.92 : spow_0((x + 0.055) / 1.055, 2.4);
  };
  var SRGBTransferFunctions_instance;
  function SRGBTransferFunctions_getInstance() {
    return SRGBTransferFunctions_instance;
  }
  function RGBColorSpace_0(name, whitePoint, transferFunctions, r, g, b) {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    return new RGBColorSpaceImpl(name, whitePoint, transferFunctions, r, g, b, RGBColorSpace$lambda);
  }
  function ACESccTransferFunctions() {
    ACESccTransferFunctions_instance = this;
    this.g29_1 = 3.0517578125E-5;
    this.h29_1 = 1.52587890625E-5;
    this.i29_1 = -0.3013698630136986;
    var tmp = this;
    // Inline function 'kotlin.math.log2' call
    tmp.j29_1 = (log2(65504.0) + 9.72) / 17.52;
  }
  protoOf(ACESccTransferFunctions).y27 = function (x) {
    var tmp;
    if (x <= -0.3013698630136986) {
      tmp = (spow_0(2.0, x * 17.52 - 9.72) - 1.52587890625E-5) * 2.0;
    } else if (x < this.j29_1) {
      // Inline function 'kotlin.math.pow' call
      var x_0 = x * 17.52 - 9.72;
      tmp = Math.pow(2.0, x_0);
    } else {
      tmp = 65504.0;
    }
    return tmp;
  };
  protoOf(ACESccTransferFunctions).z27 = function (x) {
    var tmp;
    if (x < 3.0517578125E-5) {
      // Inline function 'kotlin.math.log2' call
      var x_0 = 1.52587890625E-5 + coerceAtLeast_0(x, 0.0) / 2.0;
      tmp = (log2(x_0) + 9.72) / 17.52;
    } else {
      // Inline function 'kotlin.math.log2' call
      tmp = (log2(x) + 9.72) / 17.52;
    }
    return tmp;
  };
  var ACESccTransferFunctions_instance;
  function ACESccTransferFunctions_getInstance() {
    if (ACESccTransferFunctions_instance == null)
      new ACESccTransferFunctions();
    return ACESccTransferFunctions_instance;
  }
  function ACEScctTransferFunctions() {
    ACEScctTransferFunctions_instance = this;
    this.k29_1 = 10.5402377416545;
    this.l29_1 = 0.0729055341958355;
    var tmp = this;
    // Inline function 'kotlin.math.log2' call
    tmp.m29_1 = (log2(65504.0) + 9.72) / 17.52;
  }
  protoOf(ACEScctTransferFunctions).y27 = function (x) {
    var tmp;
    if (x <= 0.155251141552511) {
      tmp = (x - 0.0729055341958355) / 10.5402377416545;
    } else if (x < this.m29_1) {
      // Inline function 'kotlin.math.pow' call
      var x_0 = x * 17.52 - 9.72;
      tmp = Math.pow(2.0, x_0);
    } else {
      tmp = 65504.0;
    }
    return tmp;
  };
  protoOf(ACEScctTransferFunctions).z27 = function (x) {
    var tmp;
    if (x < 0.0078125) {
      tmp = 10.5402377416545 * x + 0.0729055341958355;
    } else {
      // Inline function 'kotlin.math.log2' call
      tmp = (log2(x) + 9.72) / 17.52;
    }
    return tmp;
  };
  var ACEScctTransferFunctions_instance;
  function ACEScctTransferFunctions_getInstance() {
    if (ACEScctTransferFunctions_instance == null)
      new ACEScctTransferFunctions();
    return ACEScctTransferFunctions_instance;
  }
  function BT2020TransferFunctions() {
    BT2020TransferFunctions_instance = this;
    this.n29_1 = 1.0993;
    this.o29_1 = 0.0181;
    var tmp = this;
    // Inline function 'kotlin.math.pow' call
    tmp.p29_1 = 1.0993 * Math.pow(0.0181, 0.45) - (1.0993 - 1);
  }
  protoOf(BT2020TransferFunctions).y27 = function (x) {
    return numberToDouble(x < this.p29_1 ? x / 4.5 : spow_0((x + (1.0993 - 1)) / 1.0993, 1 / 0.45));
  };
  protoOf(BT2020TransferFunctions).z27 = function (x) {
    return x < 0.0181 ? 4.5 * x : 1.0993 * spow(x, 0.45) - (1.0993 - 1);
  };
  var BT2020TransferFunctions_instance;
  function BT2020TransferFunctions_getInstance() {
    if (BT2020TransferFunctions_instance == null)
      new BT2020TransferFunctions();
    return BT2020TransferFunctions_instance;
  }
  function BT709TransferFunctions() {
    BT709TransferFunctions_instance = this;
    this.q29_1 = 1.099 * spow_0(0.018, 0.45) - 0.099;
  }
  protoOf(BT709TransferFunctions).y27 = function (x) {
    return numberToDouble(x < this.q29_1 ? x / 4.5 : spow_0((x + 0.099) / 1.099, 1 / 0.45));
  };
  protoOf(BT709TransferFunctions).z27 = function (x) {
    return x < 0.018 ? 4.5 * x : 1.099 * spow(x, 0.45) - 0.099;
  };
  var BT709TransferFunctions_instance;
  function BT709TransferFunctions_getInstance() {
    if (BT709TransferFunctions_instance == null)
      new BT709TransferFunctions();
    return BT709TransferFunctions_instance;
  }
  function ROMMTransferFunctions() {
    this.r29_1 = 0.001953;
  }
  protoOf(ROMMTransferFunctions).y27 = function (x) {
    return x < 16 * 0.001953 ? x / 16.0 : spow(x, 1.8);
  };
  protoOf(ROMMTransferFunctions).z27 = function (x) {
    return x < 0.001953 ? x * 16.0 : spow(x, 1.0 / 1.8);
  };
  var ROMMTransferFunctions_instance;
  function ROMMTransferFunctions_getInstance() {
    return ROMMTransferFunctions_instance;
  }
  function rgbToXyzMatrix(whitePoint, r, g, b) {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    var primaries = _Matrix___init__impl__q3kp4w_0(r.s29_1, g.s29_1, b.s29_1, r.t29_1, g.t29_1, b.t29_1, r.v29(), g.v29(), b.v29());
    var wp = whitePoint.x25_1;
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var this_0 = inverse(primaries);
    var v0 = wp.w29();
    var v1 = wp.u29_1;
    var v2 = wp.x29();
    // Inline function 'com.github.ajalt.colormath.model.rgbToXyzMatrix.<anonymous>' call
    var x = Matrix__get_impl_xogbpk(this_0, 0, 0) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 0) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 0) * v2;
    var y = Matrix__get_impl_xogbpk(this_0, 0, 1) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 1) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 1) * v2;
    var z = Matrix__get_impl_xogbpk(this_0, 0, 2) * v0 + Matrix__get_impl_xogbpk(this_0, 1, 2) * v1 + Matrix__get_impl_xogbpk(this_0, 2, 2) * v2;
    return dotDiagonal(primaries, x, y, z);
  }
  function RGBColorSpace$lambda($this$RGBColorSpaceImpl, color) {
    _init_properties_RGBColorSpaces_kt__nc9fsz();
    var tmp;
    if (color instanceof RGB) {
      tmp = color.l28($this$RGBColorSpaceImpl);
    } else {
      tmp = color.m25().r28($this$RGBColorSpaceImpl);
    }
    return tmp;
  }
  var properties_initialized_RGBColorSpaces_kt_fsnpad;
  function _init_properties_RGBColorSpaces_kt__nc9fsz() {
    if (!properties_initialized_RGBColorSpaces_kt_fsnpad) {
      properties_initialized_RGBColorSpaces_kt_fsnpad = true;
      SRGB_R = xyY_init_$Create$(0.64, 0.33);
      SRGB_G = xyY_init_$Create$(0.3, 0.6);
      SRGB_B = xyY_init_$Create$(0.15, 0.06);
      ACES_WHITE_POINT = new WhitePoint('ACES', xyY_init_$Create$(0.32168, 0.33767));
      ACES_AP0_R = xyY_init_$Create$(0.7347, 0.2653);
      ACES_AP0_G = xyY_init_$Create$(0.0, 1.0);
      ACES_AP0_B = xyY_init_$Create$(1.0E-4, -0.077);
      ACES_AP1_R = xyY_init_$Create$(0.713, 0.293);
      ACES_AP1_G = xyY_init_$Create$(0.165, 0.83);
      ACES_AP1_B = xyY_init_$Create$(0.128, 0.044);
    }
  }
  function Companion_3() {
    Companion_instance_3 = this;
    this.y29_1 = XYZColorSpaces_getInstance().z29_1;
  }
  protoOf(Companion_3).w26 = function (x, y, z, alpha) {
    return this.y29_1.w26(x, y, z, alpha);
  };
  protoOf(Companion_3).g28 = function () {
    return this.y29_1.g28();
  };
  protoOf(Companion_3).i26 = function () {
    return this.y29_1.i26();
  };
  protoOf(Companion_3).hashCode = function () {
    return hashCode(XYZColorSpaces_getInstance().z29_1);
  };
  protoOf(Companion_3).equals = function (other) {
    return equals(XYZColorSpaces_getInstance().z29_1, other);
  };
  var Companion_instance_3;
  function Companion_getInstance_3() {
    if (Companion_instance_3 == null)
      new Companion_3();
    return Companion_instance_3;
  }
  function adaptToM($this, space, m, mi) {
    if (space.g28().equals($this.q28_1.g28()))
      return $this;
    var transform = chromaticAdaptationMatrix(space, $this.q28_1.g28().x25_1, m, mi);
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var v0 = $this.m28_1;
    var v1 = $this.n28_1;
    var v2 = $this.o28_1;
    // Inline function 'com.github.ajalt.colormath.model.XYZ.adaptToM.<anonymous>' call
    var xx = Matrix__get_impl_xogbpk(transform, 0, 0) * v0 + Matrix__get_impl_xogbpk(transform, 1, 0) * v1 + Matrix__get_impl_xogbpk(transform, 2, 0) * v2;
    var yy = Matrix__get_impl_xogbpk(transform, 0, 1) * v0 + Matrix__get_impl_xogbpk(transform, 1, 1) * v1 + Matrix__get_impl_xogbpk(transform, 2, 1) * v2;
    var zz = Matrix__get_impl_xogbpk(transform, 0, 2) * v0 + Matrix__get_impl_xogbpk(transform, 1, 2) * v1 + Matrix__get_impl_xogbpk(transform, 2, 2) * v2;
    return space.w26(xx, yy, zz, $this.p28_1);
  }
  function XYZ(x, y, z, alpha, space) {
    Companion_getInstance_3();
    this.m28_1 = x;
    this.n28_1 = y;
    this.o28_1 = z;
    this.p28_1 = alpha;
    this.q28_1 = space;
  }
  protoOf(XYZ).k25 = function () {
    return this.q28_1;
  };
  protoOf(XYZ).b2a = function (space) {
    return adaptToM(this, space, get_CAT02_XYZ_TO_LMS(), get_CAT02_LMS_TO_XYZ());
  };
  protoOf(XYZ).r28 = function (space) {
    var _destruct__k2r9zo = this.b2a(XYZColorSpace_0(space.g28()));
    var x = _destruct__k2r9zo.ha();
    var y = _destruct__k2r9zo.ia();
    var z = _destruct__k2r9zo.vi();
    var f = space.p27();
    // Inline function 'com.github.ajalt.colormath.internal.dot' call
    var this_0 = _Matrix___init__impl__q3kp4w(space.f28());
    // Inline function 'com.github.ajalt.colormath.model.XYZ.toRGB.<anonymous>' call
    var r = Matrix__get_impl_xogbpk(this_0, 0, 0) * x + Matrix__get_impl_xogbpk(this_0, 1, 0) * y + Matrix__get_impl_xogbpk(this_0, 2, 0) * z;
    var g = Matrix__get_impl_xogbpk(this_0, 0, 1) * x + Matrix__get_impl_xogbpk(this_0, 1, 1) * y + Matrix__get_impl_xogbpk(this_0, 2, 1) * z;
    var b = Matrix__get_impl_xogbpk(this_0, 0, 2) * x + Matrix__get_impl_xogbpk(this_0, 1, 2) * y + Matrix__get_impl_xogbpk(this_0, 2, 2) * z;
    return space.w26(f.z27(r), f.z27(g), f.z27(b), this.p28_1);
  };
  protoOf(XYZ).l25 = function () {
    return this.r28(RGBColorSpaces_getInstance().d27_1);
  };
  protoOf(XYZ).m25 = function () {
    return this;
  };
  protoOf(XYZ).ha = function () {
    return this.m28_1;
  };
  protoOf(XYZ).ia = function () {
    return this.n28_1;
  };
  protoOf(XYZ).vi = function () {
    return this.o28_1;
  };
  protoOf(XYZ).toString = function () {
    return 'XYZ(x=' + this.m28_1 + ', y=' + this.n28_1 + ', z=' + this.o28_1 + ', alpha=' + this.p28_1 + ', space=' + toString(this.q28_1) + ')';
  };
  protoOf(XYZ).hashCode = function () {
    var result = getNumberHashCode(this.m28_1);
    result = imul(result, 31) + getNumberHashCode(this.n28_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.o28_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.p28_1) | 0;
    result = imul(result, 31) + hashCode(this.q28_1) | 0;
    return result;
  };
  protoOf(XYZ).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof XYZ))
      return false;
    var tmp0_other_with_cast = other instanceof XYZ ? other : THROW_CCE();
    if (!equals(this.m28_1, tmp0_other_with_cast.m28_1))
      return false;
    if (!equals(this.n28_1, tmp0_other_with_cast.n28_1))
      return false;
    if (!equals(this.o28_1, tmp0_other_with_cast.o28_1))
      return false;
    if (!equals(this.p28_1, tmp0_other_with_cast.p28_1))
      return false;
    if (!equals(this.q28_1, tmp0_other_with_cast.q28_1))
      return false;
    return true;
  };
  function XYZColorSpace() {
  }
  function XYZColorSpace_0(whitePoint) {
    return whitePoint.equals(Illuminant_getInstance().d26_1) ? XYZColorSpaces_getInstance().z29_1 : whitePoint.equals(Illuminant_getInstance().b26_1) ? XYZColorSpaces_getInstance().a2a_1 : new XYZColorSpaceImpl(whitePoint);
  }
  function XYZColorSpaces() {
    XYZColorSpaces_instance = this;
    this.z29_1 = new XYZColorSpaceImpl(Illuminant_getInstance().d26_1);
    this.a2a_1 = new XYZColorSpaceImpl(Illuminant_getInstance().b26_1);
  }
  var XYZColorSpaces_instance;
  function XYZColorSpaces_getInstance() {
    if (XYZColorSpaces_instance == null)
      new XYZColorSpaces();
    return XYZColorSpaces_instance;
  }
  function chromaticAdaptationMatrix(_this__u8e3s4, srcWp, xyzToLms, lmsToXyz) {
    xyzToLms = xyzToLms === VOID ? get_CAT02_XYZ_TO_LMS() : xyzToLms;
    lmsToXyz = lmsToXyz === VOID ? get_CAT02_LMS_TO_XYZ() : lmsToXyz;
    var dstWp = _this__u8e3s4.g28().x25_1;
    var src = dot_0(xyzToLms, srcWp.w29(), srcWp.u29_1, srcWp.x29());
    var dst = dot_0(xyzToLms, dstWp.w29(), dstWp.u29_1, dstWp.x29());
    return dot(dotDiagonal(lmsToXyz, _Vector___get_l__impl__envr1l(dst) / _Vector___get_l__impl__envr1l(src), _Vector___get_m__impl__e5qq0m(dst) / _Vector___get_m__impl__e5qq0m(src), _Vector___get_s__impl__pzuljk(dst) / _Vector___get_s__impl__pzuljk(src)), xyzToLms);
  }
  function XYZColorSpaceImpl(whitePoint) {
    this.c2a_1 = whitePoint;
    this.d2a_1 = zeroOneComponentInfo('XYZ');
  }
  protoOf(XYZColorSpaceImpl).g28 = function () {
    return this.c2a_1;
  };
  protoOf(XYZColorSpaceImpl).i26 = function () {
    return this.d2a_1;
  };
  protoOf(XYZColorSpaceImpl).toString = function () {
    return 'XYZColorSpace(' + this.c2a_1.toString() + ')';
  };
  protoOf(XYZColorSpaceImpl).w26 = function (x, y, z, alpha) {
    return new XYZ(x, y, z, alpha, this);
  };
  protoOf(XYZColorSpaceImpl).hashCode = function () {
    return this.c2a_1.hashCode();
  };
  protoOf(XYZColorSpaceImpl).equals = function (other) {
    var tmp;
    if (!(other == null) ? isInterface(other, XYZColorSpace) : false) {
      tmp = this.c2a_1.equals(other.g28());
    } else {
      tmp = false;
    }
    return tmp;
  };
  function xyY_init_$Init$(x, y, Y, $this) {
    Y = Y === VOID ? 1.0 : Y;
    xyY.call($this, numberToDouble(x), numberToDouble(y), numberToDouble(Y));
    return $this;
  }
  function xyY_init_$Create$(x, y, Y) {
    return xyY_init_$Init$(x, y, Y, objectCreate(protoOf(xyY)));
  }
  function xyY(x, y, Y) {
    Y = Y === VOID ? 1.0 : Y;
    this.s29_1 = x;
    this.t29_1 = y;
    this.u29_1 = Y;
  }
  protoOf(xyY).v29 = function () {
    return 1 - this.s29_1 - this.t29_1;
  };
  protoOf(xyY).w29 = function () {
    return this.s29_1 * this.u29_1 / this.t29_1;
  };
  protoOf(xyY).x29 = function () {
    return (1 - this.s29_1 - this.t29_1) * this.u29_1 / this.t29_1;
  };
  protoOf(xyY).toString = function () {
    return 'xyY(x=' + this.s29_1 + ', y=' + this.t29_1 + ', Y=' + this.u29_1 + ')';
  };
  protoOf(xyY).hashCode = function () {
    var result = getNumberHashCode(this.s29_1);
    result = imul(result, 31) + getNumberHashCode(this.t29_1) | 0;
    result = imul(result, 31) + getNumberHashCode(this.u29_1) | 0;
    return result;
  };
  protoOf(xyY).equals = function (other) {
    if (this === other)
      return true;
    if (!(other instanceof xyY))
      return false;
    var tmp0_other_with_cast = other instanceof xyY ? other : THROW_CCE();
    if (!equals(this.s29_1, tmp0_other_with_cast.s29_1))
      return false;
    if (!equals(this.t29_1, tmp0_other_with_cast.t29_1))
      return false;
    if (!equals(this.u29_1, tmp0_other_with_cast.u29_1))
      return false;
    return true;
  };
  //region block: post-declaration
  protoOf(Ansi16).m25 = toXYZ;
  protoOf(Ansi256).m25 = toXYZ;
  protoOf(HSV).m25 = toXYZ;
  protoOf(Companion_2).k26 = invoke$default;
  protoOf(Companion_2).p26 = invoke$default_0;
  protoOf(Companion_2).l26 = from255$default;
  protoOf(SRGB).k26 = invoke$default;
  protoOf(SRGB).p26 = invoke$default_0;
  protoOf(SRGB).l26 = from255$default;
  protoOf(RGBColorSpaceImpl).k26 = invoke$default;
  protoOf(RGBColorSpaceImpl).b28 = invoke;
  protoOf(RGBColorSpaceImpl).p26 = invoke$default_0;
  protoOf(RGBColorSpaceImpl).d28 = invoke_0;
  protoOf(RGBColorSpaceImpl).c28 = from255;
  protoOf(RGBColorSpaceImpl).l26 = from255$default;
  //endregion
  //region block: init
  PqNonlinearity_instance = new PqNonlinearity();
  LinearTransferFunctions_instance = new LinearTransferFunctions();
  SRGBTransferFunctions_instance = new SRGBTransferFunctions();
  ROMMTransferFunctions_instance = new ROMMTransferFunctions();
  //endregion
  //region block: exports
  _.$_$ = _.$_$ || {};
  _.$_$.a = Ansi16;
  _.$_$.b = Ansi256;
  _.$_$.c = Companion_getInstance_2;
  //endregion
  return _;
}(module.exports, require('./kotlin-kotlin-stdlib.js')));

//# sourceMappingURL=colormath-root-colormath.js.map
